// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

//
// This file was autogenerated by a tool.
// Do not modify it.
//

namespace Microsoft.Azure.Batch
{
    using Models = Microsoft.Azure.Batch.Protocol.Models;
    using System;
    using System.Collections.Generic;
    using System.Linq;

    /// <summary>
    /// The status of the Job Preparation task and Job Release task on a compute node.
    /// </summary>
    public partial class JobPreparationAndReleaseTaskExecutionInformation : IPropertyMetadata
    {
        private readonly string computeNodeId;
        private readonly string computeNodeUrl;
        private readonly JobPreparationTaskExecutionInformation jobPreparationTaskExecutionInformation;
        private readonly JobReleaseTaskExecutionInformation jobReleaseTaskExecutionInformation;
        private readonly string poolId;

        #region Constructors

        internal JobPreparationAndReleaseTaskExecutionInformation(Models.JobPreparationAndReleaseTaskExecutionInformation protocolObject)
        {
            this.computeNodeId = protocolObject.NodeId;
            this.computeNodeUrl = protocolObject.NodeUrl;
            this.jobPreparationTaskExecutionInformation = UtilitiesInternal.CreateObjectWithNullCheck(protocolObject.JobPreparationTaskExecutionInfo, o => new JobPreparationTaskExecutionInformation(o).Freeze());
            this.jobReleaseTaskExecutionInformation = UtilitiesInternal.CreateObjectWithNullCheck(protocolObject.JobReleaseTaskExecutionInfo, o => new JobReleaseTaskExecutionInformation(o).Freeze());
            this.poolId = protocolObject.PoolId;
        }

        #endregion Constructors

        #region JobPreparationAndReleaseTaskExecutionInformation

        /// <summary>
        /// Gets the id of the compute node.
        /// </summary>
        public string ComputeNodeId
        {
            get { return this.computeNodeId; }
        }

        /// <summary>
        /// Gets the URL of the compute node.
        /// </summary>
        public string ComputeNodeUrl
        {
            get { return this.computeNodeUrl; }
        }

        /// <summary>
        /// Gets details of the <see cref="CloudJob.JobPreparationTask">Job Preparation task</see> on this compute node.
        /// </summary>
        public JobPreparationTaskExecutionInformation JobPreparationTaskExecutionInformation
        {
            get { return this.jobPreparationTaskExecutionInformation; }
        }

        /// <summary>
        /// Gets details of the <see cref="CloudJob.JobReleaseTask">Job Release task</see> on this compute node.
        /// </summary>
        public JobReleaseTaskExecutionInformation JobReleaseTaskExecutionInformation
        {
            get { return this.jobReleaseTaskExecutionInformation; }
        }

        /// <summary>
        /// Gets the id of the pool containing the compute node.
        /// </summary>
        public string PoolId
        {
            get { return this.poolId; }
        }

        #endregion // JobPreparationAndReleaseTaskExecutionInformation

        #region IPropertyMetadata

        bool IModifiable.HasBeenModified
        {
            //This class is compile time readonly so it cannot have been modified
            get { return false; }
        }

        bool IReadOnly.IsReadOnly
        {
            get { return true; }
            set
            {
                // This class is compile time readonly already
            }
        }

        #endregion // IPropertyMetadata
    }
}