// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Batch.Protocol.Models
{
    using System.Linq;

    /// <summary>
    /// Information about the most recent job to run under the job schedule.
    /// </summary>
    public partial class RecentJob
    {
        /// <summary>
        /// Initializes a new instance of the RecentJob class.
        /// </summary>
        public RecentJob() { }

        /// <summary>
        /// Initializes a new instance of the RecentJob class.
        /// </summary>
        /// <param name="id">The id of the job.</param>
        /// <param name="url">The URL of the job.</param>
        public RecentJob(string id = default(string), string url = default(string))
        {
            Id = id;
            Url = url;
        }

        /// <summary>
        /// Gets or sets the id of the job.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the URL of the job.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "url")]
        public string Url { get; set; }

    }
}
