// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.KeyVault.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The contacts for the vault certificates.
    /// </summary>
    public partial class Contacts
    {
        /// <summary>
        /// Initializes a new instance of the Contacts class.
        /// </summary>
        public Contacts() { }

        /// <summary>
        /// Initializes a new instance of the Contacts class.
        /// </summary>
        /// <param name="id">Identifier for the contacts collection.</param>
        /// <param name="contactList">The contact list for the vault
        /// certificates.</param>
        public Contacts(string id = default(string), IList<Contact> contactList = default(IList<Contact>))
        {
            Id = id;
            ContactList = contactList;
        }

        /// <summary>
        /// Gets identifier for the contacts collection.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; private set; }

        /// <summary>
        /// Gets or sets the contact list for the vault certificates.
        /// </summary>
        [JsonProperty(PropertyName = "contacts")]
        public IList<Contact> ContactList { get; set; }

    }
}
