// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Describes scaling information of a sku.
    /// </summary>
    public partial class VirtualMachineScaleSetSkuCapacity
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetSkuCapacity class.
        /// </summary>
        public VirtualMachineScaleSetSkuCapacity() { }

        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetSkuCapacity class.
        /// </summary>
        public VirtualMachineScaleSetSkuCapacity(long? minimum = default(long?), long? maximum = default(long?), long? defaultCapacity = default(long?), VirtualMachineScaleSetSkuScaleType? scaleType = default(VirtualMachineScaleSetSkuScaleType?))
        {
            Minimum = minimum;
            Maximum = maximum;
            DefaultCapacity = defaultCapacity;
            ScaleType = scaleType;
        }

        /// <summary>
        /// the minimum capacity.
        /// </summary>
        [JsonProperty(PropertyName = "minimum")]
        public long? Minimum { get; private set; }

        /// <summary>
        /// the maximum capacity that can be set.
        /// </summary>
        [JsonProperty(PropertyName = "maximum")]
        public long? Maximum { get; private set; }

        /// <summary>
        /// the default capacity.
        /// </summary>
        [JsonProperty(PropertyName = "defaultCapacity")]
        public long? DefaultCapacity { get; private set; }

        /// <summary>
        /// the scale type applicable to the sku. Possible values include:
        /// 'Automatic', 'None'
        /// </summary>
        [JsonProperty(PropertyName = "scaleType")]
        public VirtualMachineScaleSetSkuScaleType? ScaleType { get; private set; }

    }
}
