// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    public partial class KeyVaultMetaInfo
    {
        /// <summary>
        /// Initializes a new instance of the KeyVaultMetaInfo class.
        /// </summary>
        public KeyVaultMetaInfo() { }

        /// <summary>
        /// Initializes a new instance of the KeyVaultMetaInfo class.
        /// </summary>
        /// <param name="keyVaultResourceId">The resource identifier for the
        /// user managed Key Vault being used to encrypt.</param>
        /// <param name="encryptionKeyName">The name of the user managed
        /// encryption key.</param>
        /// <param name="encryptionKeyVersion">The version of the user managed
        /// encryption key.</param>
        public KeyVaultMetaInfo(string keyVaultResourceId = default(string), string encryptionKeyName = default(string), string encryptionKeyVersion = default(string))
        {
            KeyVaultResourceId = keyVaultResourceId;
            EncryptionKeyName = encryptionKeyName;
            EncryptionKeyVersion = encryptionKeyVersion;
        }

        /// <summary>
        /// Gets or sets the resource identifier for the user managed Key
        /// Vault being used to encrypt.
        /// </summary>
        [JsonProperty(PropertyName = "keyVaultResourceId")]
        public string KeyVaultResourceId { get; set; }

        /// <summary>
        /// Gets or sets the name of the user managed encryption key.
        /// </summary>
        [JsonProperty(PropertyName = "encryptionKeyName")]
        public string EncryptionKeyName { get; set; }

        /// <summary>
        /// Gets or sets the version of the user managed encryption key.
        /// </summary>
        [JsonProperty(PropertyName = "encryptionKeyVersion")]
        public string EncryptionKeyVersion { get; set; }

    }
}
