// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DevTestLabs.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Result of a policy set evaluation.
    /// </summary>
    public partial class PolicySetResult
    {
        /// <summary>
        /// Initializes a new instance of the PolicySetResult class.
        /// </summary>
        public PolicySetResult() { }

        /// <summary>
        /// Initializes a new instance of the PolicySetResult class.
        /// </summary>
        public PolicySetResult(bool? hasError = default(bool?), IList<PolicyViolation> policyViolations = default(IList<PolicyViolation>))
        {
            HasError = hasError;
            PolicyViolations = policyViolations;
        }

        /// <summary>
        /// A value indicating whether this policy set evaluation has
        /// discovered violations.
        /// </summary>
        [JsonProperty(PropertyName = "hasError")]
        public bool? HasError { get; set; }

        /// <summary>
        /// The list of policy violations.
        /// </summary>
        [JsonProperty(PropertyName = "policyViolations")]
        public IList<PolicyViolation> PolicyViolations { get; set; }

    }
}
