// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.EventHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Description of Consumer Group Resource.
    /// </summary>
    [JsonTransformation]
    public partial class ConsumerGroupResource : Resource
    {
        /// <summary>
        /// Initializes a new instance of the ConsumerGroupResource class.
        /// </summary>
        public ConsumerGroupResource() { }

        /// <summary>
        /// Initializes a new instance of the ConsumerGroupResource class.
        /// </summary>
        public ConsumerGroupResource(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), DateTime? createdAt = default(DateTime?), string eventHubPath = default(string), DateTime? updatedAt = default(DateTime?), string userMetadata = default(string))
            : base(location, id, name, type, tags)
        {
            CreatedAt = createdAt;
            EventHubPath = eventHubPath;
            UpdatedAt = updatedAt;
            UserMetadata = userMetadata;
        }

        /// <summary>
        /// Exact time the message was created.
        /// </summary>
        [JsonProperty(PropertyName = "properties.createdAt")]
        public DateTime? CreatedAt { get; set; }

        /// <summary>
        /// The path of the event hub.
        /// </summary>
        [JsonProperty(PropertyName = "properties.eventHubPath")]
        public string EventHubPath { get; set; }

        /// <summary>
        /// The exact time the message has been updated.
        /// </summary>
        [JsonProperty(PropertyName = "properties.updatedAt")]
        public DateTime? UpdatedAt { get; set; }

        /// <summary>
        /// The user metadata.
        /// </summary>
        [JsonProperty(PropertyName = "properties.userMetadata")]
        public string UserMetadata { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
