// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Insights.Models
{
    using System.Linq;

    /// <summary>
    /// Autoscale notification.
    /// </summary>
    public partial class AutoscaleNotification
    {
        /// <summary>
        /// Initializes a new instance of the AutoscaleNotification class.
        /// </summary>
        public AutoscaleNotification() { }

        /// <summary>
        /// Initializes a new instance of the AutoscaleNotification class.
        /// </summary>
        /// <param name="email">the email notification.</param>
        /// <param name="webhooks">the collection of webhook
        /// notifications.</param>
        public AutoscaleNotification(EmailNotification email = default(EmailNotification), System.Collections.Generic.IList<WebhookNotification> webhooks = default(System.Collections.Generic.IList<WebhookNotification>))
        {
            Email = email;
            Webhooks = webhooks;
        }
        /// <summary>
        /// Static constructor for AutoscaleNotification class.
        /// </summary>
        static AutoscaleNotification()
        {
            Operation = "Scale";
        }

        /// <summary>
        /// Gets or sets the email notification.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "email")]
        public EmailNotification Email { get; set; }

        /// <summary>
        /// Gets or sets the collection of webhook notifications.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "webhooks")]
        public System.Collections.Generic.IList<WebhookNotification> Webhooks { get; set; }

        /// <summary>
        /// the operation associated with the notification and it's value must
        /// be "scale"
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "operation")]
        public static string Operation { get; private set; }

    }
}
