// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Intune.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Default Statuses entity for the given tenant.
    /// </summary>
    public partial class StatusesDefault : Resource
    {
        /// <summary>
        /// Initializes a new instance of the StatusesDefault class.
        /// </summary>
        public StatusesDefault() { }

        /// <summary>
        /// Initializes a new instance of the StatusesDefault class.
        /// </summary>
        public StatusesDefault(string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string location = default(string), int? deployedPolicies = default(int?), int? enrolledUsers = default(int?), int? flaggedUsers = default(int?), DateTime? lastModifiedTime = default(DateTime?), int? policyAppliedUsers = default(int?), string status = default(string), int? wipeFailedApps = default(int?), int? wipePendingApps = default(int?), int? wipeSucceededApps = default(int?))
            : base(id, name, type, tags, location)
        {
            DeployedPolicies = deployedPolicies;
            EnrolledUsers = enrolledUsers;
            FlaggedUsers = flaggedUsers;
            LastModifiedTime = lastModifiedTime;
            PolicyAppliedUsers = policyAppliedUsers;
            Status = status;
            WipeFailedApps = wipeFailedApps;
            WipePendingApps = wipePendingApps;
            WipeSucceededApps = wipeSucceededApps;
        }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.deployedPolicies")]
        public int? DeployedPolicies { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.enrolledUsers")]
        public int? EnrolledUsers { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.flaggedUsers")]
        public int? FlaggedUsers { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.lastModifiedTime")]
        public DateTime? LastModifiedTime { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.policyAppliedUsers")]
        public int? PolicyAppliedUsers { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.status")]
        public string Status { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.wipeFailedApps")]
        public int? WipeFailedApps { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.wipePendingApps")]
        public int? WipePendingApps { get; private set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties.wipeSucceededApps")]
        public int? WipeSucceededApps { get; private set; }

    }
}
