// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The Sku related information for the hub.
    /// </summary>
    public partial class IotHubSkuInfo
    {
        /// <summary>
        /// Initializes a new instance of the IotHubSkuInfo class.
        /// </summary>
        public IotHubSkuInfo() { }

        /// <summary>
        /// Initializes a new instance of the IotHubSkuInfo class.
        /// </summary>
        public IotHubSkuInfo(string name = default(string), IotHubSkuTier? tier = default(IotHubSkuTier?), long? capacity = default(long?))
        {
            Name = name;
            Tier = tier;
            Capacity = capacity;
        }

        /// <summary>
        /// The name of the Sku. Possible values include: 'F1', 'S1', 'S2',
        /// 'S3'
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// The tier. Possible values include: 'Free', 'Standard'
        /// </summary>
        [JsonProperty(PropertyName = "tier")]
        public IotHubSkuTier? Tier { get; private set; }

        /// <summary>
        /// The number of units being provisioned. Range of values [For F1:
        /// 1-1, S1: 1-200, S2: 1-200, S3: 1-10]. To go above this range,
        /// call support.
        /// </summary>
        [JsonProperty(PropertyName = "capacity")]
        public long? Capacity { get; set; }

    }
}
