// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.IotHub.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The properties related to the registry statistics.
    /// </summary>
    public partial class RegistryStatistics
    {
        /// <summary>
        /// Initializes a new instance of the RegistryStatistics class.
        /// </summary>
        public RegistryStatistics() { }

        /// <summary>
        /// Initializes a new instance of the RegistryStatistics class.
        /// </summary>
        public RegistryStatistics(long? totalDeviceCount = default(long?), long? enabledDeviceCount = default(long?), long? disabledDeviceCount = default(long?))
        {
            TotalDeviceCount = totalDeviceCount;
            EnabledDeviceCount = enabledDeviceCount;
            DisabledDeviceCount = disabledDeviceCount;
        }

        /// <summary>
        /// The total device count.
        /// </summary>
        [JsonProperty(PropertyName = "totalDeviceCount")]
        public long? TotalDeviceCount { get; set; }

        /// <summary>
        /// The enabled device count.
        /// </summary>
        [JsonProperty(PropertyName = "enabledDeviceCount")]
        public long? EnabledDeviceCount { get; set; }

        /// <summary>
        /// The disabled device count.
        /// </summary>
        [JsonProperty(PropertyName = "disabledDeviceCount")]
        public long? DisabledDeviceCount { get; set; }

    }
}
