// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Defines the graph of modules making up the machine learning solution.
    /// </summary>
    public partial class GraphPackage
    {
        /// <summary>
        /// Initializes a new instance of the GraphPackage class.
        /// </summary>
        public GraphPackage() { }

        /// <summary>
        /// Initializes a new instance of the GraphPackage class.
        /// </summary>
        /// <param name="nodes">The set of nodes making up the graph, provided
        /// as a nodeId to GraphNode map</param>
        /// <param name="edges">The list of edges making up the graph.</param>
        /// <param name="graphParameters">The collection of global parameters
        /// for the graph, given as a global parameter name to GraphParameter
        /// map. Each parameter here has a 1:1 match with the global
        /// parameters values map declared at the WebServiceProperties
        /// level.</param>
        public GraphPackage(System.Collections.Generic.IDictionary<string, GraphNode> nodes = default(System.Collections.Generic.IDictionary<string, GraphNode>), System.Collections.Generic.IList<GraphEdge> edges = default(System.Collections.Generic.IList<GraphEdge>), System.Collections.Generic.IDictionary<string, GraphParameter> graphParameters = default(System.Collections.Generic.IDictionary<string, GraphParameter>))
        {
            Nodes = nodes;
            Edges = edges;
            GraphParameters = graphParameters;
        }

        /// <summary>
        /// Gets or sets the set of nodes making up the graph, provided as a
        /// nodeId to GraphNode map
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "nodes")]
        public System.Collections.Generic.IDictionary<string, GraphNode> Nodes { get; set; }

        /// <summary>
        /// Gets or sets the list of edges making up the graph.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "edges")]
        public System.Collections.Generic.IList<GraphEdge> Edges { get; set; }

        /// <summary>
        /// Gets or sets the collection of global parameters for the graph,
        /// given as a global parameter name to GraphParameter map. Each
        /// parameter here has a 1:1 match with the global parameters values
        /// map declared at the WebServiceProperties level.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "graphParameters")]
        public System.Collections.Generic.IDictionary<string, GraphParameter> GraphParameters { get; set; }

    }
}
