// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Parameter definition for a module asset.
    /// </summary>
    public partial class ModuleAssetParameter
    {
        /// <summary>
        /// Initializes a new instance of the ModuleAssetParameter class.
        /// </summary>
        public ModuleAssetParameter() { }

        /// <summary>
        /// Initializes a new instance of the ModuleAssetParameter class.
        /// </summary>
        /// <param name="name">Parameter name.</param>
        /// <param name="parameterType">Parameter type.</param>
        /// <param name="modeValuesInfo">Definitions for nested interface
        /// parameters if this is a complex module parameter.</param>
        public ModuleAssetParameter(string name = default(string), string parameterType = default(string), System.Collections.Generic.IDictionary<string, ModeValueInfo> modeValuesInfo = default(System.Collections.Generic.IDictionary<string, ModeValueInfo>))
        {
            Name = name;
            ParameterType = parameterType;
            ModeValuesInfo = modeValuesInfo;
        }

        /// <summary>
        /// Gets or sets parameter name.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets parameter type.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "parameterType")]
        public string ParameterType { get; set; }

        /// <summary>
        /// Gets or sets definitions for nested interface parameters if this
        /// is a complex module parameter.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "modeValuesInfo")]
        public System.Collections.Generic.IDictionary<string, ModeValueInfo> ModeValuesInfo { get; set; }

    }
}
