// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// Paginated list of web services.
    /// </summary>
    public partial class PaginatedWebServicesList
    {
        /// <summary>
        /// Initializes a new instance of the PaginatedWebServicesList class.
        /// </summary>
        public PaginatedWebServicesList() { }

        /// <summary>
        /// Initializes a new instance of the PaginatedWebServicesList class.
        /// </summary>
        /// <param name="value">List of web services objects.</param>
        /// <param name="nextLink">Continuation link to be used to potentially
        /// retrieve the next page of results in the list.</param>
        public PaginatedWebServicesList(System.Collections.Generic.IList<WebService> value = default(System.Collections.Generic.IList<WebService>), string nextLink = default(string))
        {
            Value = value;
            NextLink = nextLink;
        }

        /// <summary>
        /// Gets or sets list of web services objects.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "value")]
        public System.Collections.Generic.IList<WebService> Value { get; set; }

        /// <summary>
        /// Gets or sets continuation link to be used to potentially retrieve
        /// the next page of results in the list.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "nextLink")]
        public string NextLink { get; set; }

    }
}
