// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.MachineLearning.WebServices.Models
{
    using System.Linq;

    /// <summary>
    /// The swagger 2.0 schema describing the service's inputs or outputs. See
    /// Swagger specification: http://swagger.io/specification/
    /// </summary>
    public partial class ServiceInputOutputSpecification
    {
        /// <summary>
        /// Initializes a new instance of the ServiceInputOutputSpecification
        /// class.
        /// </summary>
        public ServiceInputOutputSpecification() { }

        /// <summary>
        /// Initializes a new instance of the ServiceInputOutputSpecification
        /// class.
        /// </summary>
        /// <param name="type">The type of the entity described in swagger.
        /// Always 'object'.</param>
        /// <param name="properties">Map of name to swagger schema for each
        /// input or output of the web service.</param>
        /// <param name="title">Swagger schema title.</param>
        /// <param name="description">Swagger schema description.</param>
        public ServiceInputOutputSpecification(string type, System.Collections.Generic.IDictionary<string, TableSpecification> properties, string title = default(string), string description = default(string))
        {
            Title = title;
            Description = description;
            Type = type;
            Properties = properties;
        }

        /// <summary>
        /// Gets or sets swagger schema title.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "title")]
        public string Title { get; set; }

        /// <summary>
        /// Gets or sets swagger schema description.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "description")]
        public string Description { get; set; }

        /// <summary>
        /// Gets or sets the type of the entity described in swagger. Always
        /// 'object'.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets map of name to swagger schema for each input or
        /// output of the web service.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties")]
        public System.Collections.Generic.IDictionary<string, TableSpecification> Properties { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Type == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Type");
            }
            if (Properties == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Properties");
            }
            if (this.Properties != null)
            {
                foreach (var valueElement in this.Properties.Values)
                {
                    if (valueElement != null)
                    {
                        valueElement.Validate();
                    }
                }
            }
        }
    }
}
