// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.16.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Storage.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// An encrypted service.
    /// </summary>
    public partial class EncryptionService
    {
        /// <summary>
        /// Initializes a new instance of the EncryptionService class.
        /// </summary>
        public EncryptionService() { }

        /// <summary>
        /// Initializes a new instance of the EncryptionService class.
        /// </summary>
        public EncryptionService(bool? enabled = default(bool?), DateTime? lastEnabledTime = default(DateTime?))
        {
            Enabled = enabled;
            LastEnabledTime = lastEnabledTime;
        }

        /// <summary>
        /// A boolean indicating whether or not the service is encrypted.
        /// </summary>
        [JsonProperty(PropertyName = "enabled")]
        public bool? Enabled { get; set; }

        /// <summary>
        /// Gets a time value indicating when was the encryption enabled by
        /// the user last time. We return this value only when encryption is
        /// enabled. There might be some unencrypted blobs which were written
        /// after this time. This time is just to give a rough estimate of
        /// when encryption was enabled.
        /// </summary>
        [JsonProperty(PropertyName = "lastEnabledTime")]
        public DateTime? LastEnabledTime { get; private set; }

    }
}
