// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Application logs azure blob storage configuration
    /// </summary>
    public partial class AzureBlobStorageApplicationLogsConfig
    {
        /// <summary>
        /// Initializes a new instance of the
        /// AzureBlobStorageApplicationLogsConfig class.
        /// </summary>
        public AzureBlobStorageApplicationLogsConfig() { }

        /// <summary>
        /// Initializes a new instance of the
        /// AzureBlobStorageApplicationLogsConfig class.
        /// </summary>
        public AzureBlobStorageApplicationLogsConfig(LogLevel? level = default(LogLevel?), string sasUrl = default(string), int? retentionInDays = default(int?))
        {
            Level = level;
            SasUrl = sasUrl;
            RetentionInDays = retentionInDays;
        }

        /// <summary>
        /// Log level. Possible values for this property include: 'Off',
        /// 'Verbose', 'Information', 'Warning', 'Error'.
        /// </summary>
        [JsonProperty(PropertyName = "level")]
        public LogLevel? Level { get; set; }

        /// <summary>
        /// SAS url to a azure blob container with read/write/list/delete
        /// permissions
        /// </summary>
        [JsonProperty(PropertyName = "sasUrl")]
        public string SasUrl { get; set; }

        /// <summary>
        /// Retention in days.
        /// Remove blobs older than X days.
        /// 0 or lower means no retention.
        /// </summary>
        [JsonProperty(PropertyName = "retentionInDays")]
        public int? RetentionInDays { get; set; }

    }
}
