// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Class containting details about site recovery operation.
    /// </summary>
    public partial class CsmSiteRecoveryEntity
    {
        /// <summary>
        /// Initializes a new instance of the CsmSiteRecoveryEntity class.
        /// </summary>
        public CsmSiteRecoveryEntity() { }

        /// <summary>
        /// Initializes a new instance of the CsmSiteRecoveryEntity class.
        /// </summary>
        public CsmSiteRecoveryEntity(DateTime? snapshotTime = default(DateTime?), bool? recoverConfig = default(bool?), string siteName = default(string), string slotName = default(string))
        {
            SnapshotTime = snapshotTime;
            RecoverConfig = recoverConfig;
            SiteName = siteName;
            SlotName = slotName;
        }

        /// <summary>
        /// Point in time in which the site recover should be attempted.
        /// </summary>
        [JsonProperty(PropertyName = "snapshotTime")]
        public DateTime? SnapshotTime { get; set; }

        /// <summary>
        /// If true, then the website's configuration will be reverted to its
        /// state at SnapshotTime
        /// </summary>
        [JsonProperty(PropertyName = "recoverConfig")]
        public bool? RecoverConfig { get; set; }

        /// <summary>
        /// [Optional] Destination web app name into which web app should be
        /// recovered. This is case when new web app should be created
        /// instead.
        /// </summary>
        [JsonProperty(PropertyName = "siteName")]
        public string SiteName { get; set; }

        /// <summary>
        /// [Optional] Destination web app slot name into which web app should
        /// be recovered
        /// </summary>
        [JsonProperty(PropertyName = "slotName")]
        public string SlotName { get; set; }

    }
}
