// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.WebSites.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A host name binding object
    /// </summary>
    public partial class HostNameBinding : Resource
    {
        /// <summary>
        /// Initializes a new instance of the HostNameBinding class.
        /// </summary>
        public HostNameBinding() { }

        /// <summary>
        /// Initializes a new instance of the HostNameBinding class.
        /// </summary>
        public HostNameBinding(string location, string id = default(string), string name = default(string), string type = default(string), IDictionary<string, string> tags = default(IDictionary<string, string>), string hostNameBindingName = default(string), string siteName = default(string), string domainId = default(string), string azureResourceName = default(string), AzureResourceType? azureResourceType = default(AzureResourceType?), CustomHostNameDnsRecordType? customHostNameDnsRecordType = default(CustomHostNameDnsRecordType?), HostNameType? hostNameType = default(HostNameType?))
            : base(location, id, name, type, tags)
        {
            HostNameBindingName = hostNameBindingName;
            SiteName = siteName;
            DomainId = domainId;
            AzureResourceName = azureResourceName;
            AzureResourceType = azureResourceType;
            CustomHostNameDnsRecordType = customHostNameDnsRecordType;
            HostNameType = hostNameType;
        }

        /// <summary>
        /// Hostname
        /// </summary>
        [JsonProperty(PropertyName = "properties.name")]
        public string HostNameBindingName { get; set; }

        /// <summary>
        /// Web app name
        /// </summary>
        [JsonProperty(PropertyName = "properties.siteName")]
        public string SiteName { get; set; }

        /// <summary>
        /// Fully qualified ARM domain resource URI
        /// </summary>
        [JsonProperty(PropertyName = "properties.domainId")]
        public string DomainId { get; set; }

        /// <summary>
        /// Azure resource name
        /// </summary>
        [JsonProperty(PropertyName = "properties.azureResourceName")]
        public string AzureResourceName { get; set; }

        /// <summary>
        /// Azure resource type. Possible values for this property include:
        /// 'Website', 'TrafficManager'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.azureResourceType")]
        public AzureResourceType? AzureResourceType { get; set; }

        /// <summary>
        /// Custom DNS record type. Possible values for this property include:
        /// 'CName', 'A'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.customHostNameDnsRecordType")]
        public CustomHostNameDnsRecordType? CustomHostNameDnsRecordType { get; set; }

        /// <summary>
        /// Host name type. Possible values for this property include:
        /// 'Verified', 'Managed'.
        /// </summary>
        [JsonProperty(PropertyName = "properties.hostNameType")]
        public HostNameType? HostNameType { get; set; }

        /// <summary>
        /// Validate the object. Throws ValidationException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
        }
    }
}
